//Oscillator frequency : 8Mhz

#define LEFT 1
#define RIGHT 0

#define ON 1
#define OFF 0

#define MAX_PATTERN 8

bit direction;
bit start;
unsigned char TMR0_value = 150;
unsigned char pattern_count = 1;
unsigned char pattern[MAX_PATTERN] = {0b1000,
									0b1010,
									0b0010,
									0b0110,
									0b0100,
									0b0101,
									0b0001,
									0b1001}; //put your own pattern but be careful
											//it is faster but it uses much more memory!
											//if you add/remove pattern modify MAX_PATTERN and the code will be
											//automatically up-to-date
											//you can put 8bits patterns if you want, it will not change the required space

void interrupt()
{
  if(T0IF_bit)             //if TMR0 interrupt
  {
    T0IF_bit = 0;          //flag reset
  
    if(start == OFF))
        PORTA = 0;
       
    else
    {
		pattern_count += direction<<1;
		pattern_count--;				//LEFT -> +1
										//RIGHT -> -1
		
		if(pattern_count == 0)
			pattern_count = MAX_PATTERN
		if(pattern_count == MAX_PATTERN+1)
			pattern_count = 1
			
		PORTA = pattern[pattern_count - 1]   
    }
    
    TMR0 = TMR0_value;   //TMR0_value = 1 -> 30Hz
                          //TMR0_value = 255 -> 7812Hz
                          //by incrementing it each time in this loop you 
                          //can do a soft start (useful for a motor stepper)
	}
}

void main() {
  OPTION_REG = 0xFF;       // default value

  //ports setup
  TRISA = 0b11110000;      // 1 -> input
  TRISB = 0xFF;            // 0 -> output

  //timer setup
  T0CS_bit = 0;            //Fosc/4
  PSA_bit = 0;             //8bits prescalar

  PS0_bit = 1;
  PS1_bit = 1;
  PS2_bit = 1;             //256 prescalar
//  timer freq is now 7812Hz
  T0IF_bit = 0;             //flag reset
  T0IE_bit = 1;             //interrupt enable

  PEIE_bit = 1;
  GIE_bit = 1;             //now interrupts are enables

  while(1)
  {
     direction = LEFT;
     start = ON;
  }
}